Skip site navigation (1)Skip section navigation (2)
Date:      Sun, 27 Dec 2015 14:53:31 +0000 (UTC)
From:      Peter Holm <pho@FreeBSD.org>
To:        src-committers@freebsd.org, svn-src-user@freebsd.org
Subject:   svn commit: r292774 - user/pho/stress2/misc
Message-ID:  <201512271453.tBRErVDa082664@repo.freebsd.org>

next in thread | raw e-mail | index | archive | help
Author: pho
Date: Sun Dec 27 14:53:31 2015
New Revision: 292774
URL: https://svnweb.freebsd.org/changeset/base/292774

Log:
  Added two extreme file system load tests (3 & 4) and one regression test (5).
  
  Sponsored by:	EMC / Isilon storage division

Added:
  user/pho/stress2/misc/marcus3.sh   (contents, props changed)
  user/pho/stress2/misc/marcus4.sh   (contents, props changed)
  user/pho/stress2/misc/marcus5.sh   (contents, props changed)

Added: user/pho/stress2/misc/marcus3.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ user/pho/stress2/misc/marcus3.sh	Sun Dec 27 14:53:31 2015	(r292774)
@@ -0,0 +1,54 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2013 Peter Holm <pho@FreeBSD.org>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+# Watchdog fired:
+# https://people.freebsd.org/~pho/stress/log/kostik853.txt
+# but runs for a long time without watchdogd and deadlkres.
+
+. ../default.cfg
+
+pgrep -q watchdogd && exit 0
+dev=$(df -h `dirname $RUNDIR` | tail -1 | awk '{print $1}')
+mount | grep $dev | grep -q journaled && exit 0
+size=$((`sysctl -n hw.physmem` / 1024 / 1024))
+[ $size -gt $((4 * 1024)) ] &&
+    { echo "RAM must be capped to 4GB for this test."; exit 0; }
+[ "`sysctl -n debug.deadlkres.sleepfreq 2>/dev/null`" = "3" ] &&
+    { echo "deadlkres must be disabled for this test."; exit 0; }
+
+n=`find ../testcases -perm -1 -type f | wc -l`
+m=`su $testuser -c "limits | grep maxprocesses | awk '{print \\$NF}'"`
+export runRUNTIME=15m
+export INCARNATIONS=$((m / n))
+export swapINCARNATIONS=$INCARNATIONS
+
+su $testuser -c 'cd ..; ./run.sh marcus.cfg'

Added: user/pho/stress2/misc/marcus4.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ user/pho/stress2/misc/marcus4.sh	Sun Dec 27 14:53:31 2015	(r292774)
@@ -0,0 +1,70 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2013 Peter Holm <pho@FreeBSD.org>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+# Copy of marcus3.sh, but without the VM (page stealer) pressure.
+# Deadlock and "panic: smp_targeted_tlb_shootdown: interrupts disabled"
+# https://people.freebsd.org/~pho/stress/log/marcus4.txt
+
+. ../default.cfg
+
+pgrep -q watchdogd && exit 0
+dev=$(df -h `dirname $RUNDIR` | tail -1 | awk '{print $1}')
+mount | grep $dev | grep -q journaled && exit 0
+size=$((`sysctl -n hw.physmem` / 1024 / 1024))
+[ $size -gt $((4 * 1024)) ] &&
+    { echo "RAM must be capped to 4GB for this test."; exit 0; }
+[ "`sysctl -n debug.deadlkres.sleepfreq 2>/dev/null`" = "3" ] &&
+    { echo "deadlkres must be disabled for this test."; exit 0; }
+
+n=`find ../testcases -perm -1 -type f | wc -l`
+m=`su $testuser -c "limits | grep maxprocesses | awk '{print \\$NF}'"`
+
+export INCARNATIONS=$((m / n))
+export runRUNTIME=15m
+export LOAD=80
+export symlinkLOAD=80
+export rwLOAD=80
+export TESTPROGS="
+testcases/lockf2/lockf2
+testcases/symlink/symlink
+testcases/openat/openat
+testcases/rw/rw
+testcases/fts/fts
+testcases/link/link
+testcases/lockf/lockf
+testcases/creat/creat
+testcases/mkdir/mkdir
+testcases/rename/rename
+testcases/mkfifo/mkfifo
+"
+
+su $testuser -c 'cd ..; ./testcases/run/run $TESTPROGS'

Added: user/pho/stress2/misc/marcus5.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ user/pho/stress2/misc/marcus5.sh	Sun Dec 27 14:53:31 2015	(r292774)
@@ -0,0 +1,84 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2013 Peter Holm <pho@FreeBSD.org>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+[ `swapinfo | wc -l` -eq 1 ] && exit 0
+
+# Copy of marcus4.sh, but with a md(4) disk.
+# "panic: userret: Returning with SU cleanup request not handled" seen:
+# https://people.freebsd.org/~pho/stress/log/marcus5.txt
+# Fixed by r292541.
+
+. ../default.cfg
+
+mount | grep $mntpoint | grep -q /dev/md && umount -f $mntpoint
+mdconfig -l | grep -q md$mdstart &&  mdconfig -d -u $mdstart
+mdconfig -a -t swap -s 5g -u $mdstart
+bsdlabel -w md$mdstart auto
+newfs $newfs_flags md${mdstart}$part > /dev/null
+mount /dev/md${mdstart}$part $mntpoint
+chmod 777 $mntpoint
+
+size=$((`sysctl -n hw.physmem` / 1024 / 1024))
+[ $size -gt $((4 * 1024)) ] &&
+    echo "RAM should be capped to 4GB for this test."
+[ "`sysctl -n debug.deadlkres.sleepfreq 2>/dev/null`" = "3" ] &&
+    { echo "deadlkres must be disabled for this test."; exit 0; }
+
+n=`find ../testcases -perm -1 -type f | wc -l`
+m=`su $testuser -c "limits | grep maxprocesses | awk '{print \\$NF}'"`
+
+export RUNDIR=$mntpoint/stressX
+export INCARNATIONS=$((m / n))
+export runRUNTIME=15m
+export LOAD=80
+export symlinkLOAD=80
+export rwLOAD=80
+export TESTPROGS="
+testcases/lockf2/lockf2
+testcases/symlink/symlink
+testcases/openat/openat
+testcases/rw/rw
+testcases/fts/fts
+testcases/link/link
+testcases/lockf/lockf
+testcases/creat/creat
+testcases/mkdir/mkdir
+testcases/rename/rename
+testcases/mkfifo/mkfifo
+"
+
+su $testuser -c 'cd ..; ./testcases/run/run $TESTPROGS'
+
+while mount | grep $mntpoint | grep -q /dev/md; do
+	umount $mntpoint || sleep 1
+done
+checkfs /dev/md${mdstart}$part
+mdconfig -d -u $mdstart



Want to link to this message? Use this URL: <https://mail-archive.FreeBSD.org/cgi/mid.cgi?201512271453.tBRErVDa082664>